]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
Merge branch 'only_branches_and_tags'
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
10d92f71 1#!/bin/ksh
44058243 2#
dece74ed
AM
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
cd445739 6# -----------
cd445739 7# Exit codes:
2a5f078d 8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
67963237 20# 110 - Functions not yet implemented
cd445739 21
f8e50be5 22# Notes (todo/bugs):
f8e50be5
ER
23# - when Icon: field is present, -5 and -a5 doesn't work
24# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
19aa2571 25# - does not respect NoSource: X, and tries to cvs up such files [ example: VirtualBox-bin.spec and its Source0 ]
f8e50be5
ER
26# TODO:
27# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
1ffcdaff
ER
28# - funny bug, if source-md5 is set then builder will download from distfiles even if there is no url present:
29# Source10: forwardfix.pl
30# # Source10-md5: 8bf85f7368933a4e0cb4f875bac28733
6ca6f876
ZU
31# - builder --help:
32# basename: missing operand
33# Try `basename --help' for more information.
34# -- and the normal usage info --
35
9d99a240
ER
36PROGRAM=${0##*/}
37APPDIR=$(d=$0; [ -L "$d" ] && d=$(readlink -f "$d"); dirname "$d")
cd112f74 38RCSID='$Id: builder,v 1.645 2011/02/13 17:54:10 glen Exp $' r=${RCSID#* * } rev=${r%% *}
b0f031e7 39VERSION="v0.35/$rev"
d43959a2 40VERSIONSTRING="\
b71f5024
ER
41Build package utility from PLD Linux Packages repository
42$VERSION (C) 1999-2011 Free Penguins".
d43959a2 43
d6a77ddb 44PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 45
b7cc0c94
ER
46# required rpm-build-macros
47RPM_MACROS_VER=1.534
48
cd445739 49COMMAND="build"
64ea5308 50TARGET=""
cd445739 51
bde1c404 52SPECFILE=""
d287305c 53BE_VERBOSE=""
4003ad8c 54QUIET=""
cd445739
AM
55CLEAN=""
56DEBUG=""
57NOURLS=""
cd445739
AM
58NOCVSSPEC=""
59NODIST=""
47761337 60NOINIT=""
bc10f694 61PREFMIRRORS=""
cd445739 62UPDATE=""
cd445739
AM
63ADD5=""
64NO5=""
65ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 66CVSROOT=""
cd445739 67
6c1b2e7d
PZ
68# use rpm 4.4.6+ digest format instead of comments if non-zero
69USEDIGEST=
70
e3aa6f5e
ER
71# user agent when fetching files
72USER_AGENT="PLD/Builder($VERSION)"
73
cd445739
AM
74# It can be used i.e. in log file naming.
75# See LOGFILE example.
76DATE=`date +%Y-%m-%d_%H-%M-%S`
77
78# Example: LOGFILE='../log.$PACKAGE_NAME'
79# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
d280fd97 80# Example: LOGFILE='$PACKAGE_NAME/$PACKAGE_NAME.$DATE.log'
f5687002 81# Example: LOGFILE='$PACKAGE_NAME.$DATE.log'
cd445739
AM
82# Yes, you can use variable name! Note _single_ quotes!
83LOGFILE=''
84
85LOGDIR=""
86LOGDIROK=""
87LOGDIRFAIL=""
88LASTLOG_FILE=""
89
90CHMOD="no"
1da227e8 91CHMOD_MODE="0644"
cd445739 92RPMOPTS=""
d1c5a9a7 93RPMBUILDOPTS=""
cd445739
AM
94BCOND=""
95GROUP_BCONDS="no"
ccffa567
ER
96
97# create symlinks for tools in PACKAGE_DIR, see get_spec()
2dd0af86 98SYMLINK_TOOLS="no"
d287305c 99
100PATCHES=""
101SOURCES=""
cd445739 102ICONS=""
d287305c 103PACKAGE_RELEASE=""
104PACKAGE_VERSION=""
105PACKAGE_NAME=""
14bead22 106ASSUMED_NAME=""
fd71d65c 107PROTOCOL="http"
cd445739 108WGET_RETRIES=${MAX_WGET_RETRIES:-0}
cd445739 109
db5831da 110CVS_COMMAND=${CVS_COMMAND:-cvs}
939f2c12 111CVS_FORCE=""
f123bcb5 112CVSIGNORE_DF="yes"
939f2c12
ER
113CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
114CVS_SERVER="cvs.pld-linux.org"
cd445739 115CVSTAG=""
6892acf6 116GIT_SERVER="git://github.com/draenog"
a8f917c2 117HEAD_DETACHED=""
939f2c12 118
cd445739
AM
119RES_FILE=""
120
cd445739 121DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 122ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 123
36d03934 124DEF_NICE_LEVEL=19
86aafdbe 125SCHEDTOOL="auto"
cd445739
AM
126
127FAIL_IF_NO_SOURCES="yes"
128
18e5347d
ER
129# let get_files skip over files which are present to get those damn files fetched
130SKIP_EXISTING_FILES="no"
131
975d7b23 132TRY_UPGRADE=""
257af81b
ER
133# should the specfile be restored if upgrade failed?
134REVERT_BROKEN_UPGRADE="yes"
135
90baf90b
ER
136if rpm --specsrpm 2>/dev/null; then
137 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
ce40491a 138 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
90baf90b
ER
139else
140 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
141 if [ -x /usr/bin/rpm-getdeps ]; then
142 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
143 else
144 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
145 fi
ab4a2b6e
ER
146fi
147
90baf90b 148
cd445739
AM
149# Here we load saved user environment used to
150# predefine options set above, or passed to builder
151# in command line.
152# This one reads global system environment settings:
153if [ -f ~/etc/builderrc ]; then
154 . ~/etc/builderrc
155fi
156# And this one cascades settings using user personal
157# builder settings.
158# Example of ~/.builderrc:
159#
160#UPDATE_POLDEK_INDEXES="yes"
161#FETCH_BUILD_REQUIRES="yes"
162#REMOVE_BUILD_REQUIRES="force"
163#GROUP_BCONDS="yes"
164#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 165#TITLECHANGE=no
cd445739 166#
a83e5405 167SU_SUDO=""
cd445739
AM
168if [ -n "$HOME_ETC" ]; then
169 USER_CFG="$HOME_ETC/.builderrc"
20117088 170 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
cd445739
AM
171else
172 USER_CFG=~/.builderrc
20117088 173 BUILDER_MACROS=~/.builder-rpmmacros
cd445739
AM
174fi
175
176[ -f "$USER_CFG" ] && . "$USER_CFG"
177
86aafdbe
ER
178if [ "$SCHEDTOOL" = "auto" ]; then
179 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
180 SCHEDTOOL="schedtool -B -e"
181 else
182 SCHEDTOOL="no"
183 fi
184fi
185
ca2e6c31 186if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
187 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
188 GETURI2="$GETURI"
189 OUTFILEOPT="-O"
ca2e6c31 190elif [ -n "$USE_AXEL" ]; then
cede92b3 191 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
192 GETURI2="$GETURI"
193 OUTFILEOPT="-o"
ca2e6c31 194else
5700ee32
ER
195 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
196 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
197 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
e3aa6f5e 198 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
6f9a5d76 199
7e365483
KK
200 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
201 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
202 OUTFILEOPT="-O"
2bc5451f 203fi
11468b23 204
11468b23
AM
205GETLOCAL="cp -a"
206
207if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
208 RPM="rpm"
209 RPMBUILD="rpm"
210else
211 RPM="rpm"
212 RPMBUILD="rpmbuild"
213fi
214
c86939e2 215#
216# sanity checks
217#
218if [ -d $HOME/rpm/SOURCES ]; then
219 echo "ERROR: ~/rpm/{SPECS,SOURCES} structure is obsolete" >&2
220 echo "ERROR: get rid of your ~/rpm/SOURCES" >&2
221 exit 1
222fi
223
a8c9a155 224POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
a83e5405 225POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 226
f6711e2a 227run_poldek() {
390d081d 228 RES_FILE=$(tempfile)
cd445739
AM
229 if [ -n "$LOGFILE" ]; then
230 LOG=`eval echo $LOGFILE`
231 if [ -n "$LASTLOG_FILE" ]; then
232 echo "LASTLOG=$LOG" > $LASTLOG_FILE
233 fi
86aafdbe 234 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
235 return $exit_pldk
236 else
86aafdbe 237 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
238 return `cat ${RES_FILE}`
239 rm -rf ${RES_FILE}
240 fi
241}
242
cd445739
AM
243#---------------------------------------------
244# functions
da946cd6 245
f6711e2a 246usage() {
cd445739
AM
247 if [ -n "$DEBUG" ]; then set -xv; fi
248 echo "\
db9fdf51 249Usage: builder [-D|--debug] [-V|--version] [--short-version] [--as_anon] [-a|--add_cvs] [-b|-ba|--build]
6594293d 250[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 251[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
fd71d65c 252[-g|--get] [-h|--help] [--ftp] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
19dc5591 253[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 254[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
b3b584c5 255[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d 256[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 257[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
6594293d 258<package>[.spec][:cvstag]
2a5f078d 259
cd445739
AM
260-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
261-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
262-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
263-D, --debug - enable builder script debugging mode,
264-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
265-V, --version - output builder version string
266--short-version - output builder short version
db9fdf51
ER
267--as_anon - get files via pserver as cvs@$CVS_SERVER,
268-a, --add_cvs - try add new package to CVS.
cd445739
AM
269-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
270 from <package>.spec,
271-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
272 only package from <package>.spec,
c56807e0 273-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
274-bc - execute the %build phase of <package>.spec,
275-bi - execute the %install phase of <package>.spec
276-bl - execute the %files phase of <package>.spec
cd445739
AM
277-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
278 them into src.rpm,
6594293d 279--short-circuit - short-circuit build
cd445739 280-B, --branch - add branch
387eaf99
ER
281-c, --clean - clean all temporarily created files (in BUILD\$RPM_BUILD_ROOT) after rpmbuild commands.
282 may be used with building process.
6f10b394
ER
283-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
284 SPECS and \$RPM_BUILD_ROOT and CVS/Entries). Doesn't run
285 any rpm building.
39dcc7de 286-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 287-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
288 - setup \$CVSROOT,
289--define <macro> <value>
290 - define a macro <macro> with value <value>,
44058243
ER
291--alt_kernel <kernel>
292 - same as --define 'alt_kernel <kernel>'
cd445739
AM
293--nodeps - rpm won't check any dependences
294-g, --get - get <package>.spec and all related files from CVS repo
295 or HTTP/FTP,
296-h, --help - this message,
6c5362e5 297-jN, -j N - set %_smp_mflags to propagate concurrent jobs
fd71d65c 298--ftp, --http - use ftp or http protocol to access distfiles server
cd445739
AM
299-l <logfile>, --logtofile <logfile>
300 - log all to file,
cd445739
AM
301-ncs, --no-cvs-specs
302 - don't check specs in CVS
303-nd, --no-distfiles - don't download from distfiles
304-nm, --no-mirrors - don't download from mirror, if source URL is given,
305-nu, --no-urls - don't try to download from FTP/HTTP location,
7cbc2d88 306-ns, --no-srcs - don't download Sources/Patches
cd445739
AM
307-ns0, --no-source0 - don't download Source0
308-nn, --no-net - don't download anything from the net
a93e8cdf 309-pm, --prefer-mirrors - prefer mirrors (if any) over distfiles for SOURCES
b572253e 310--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
311-ske,
312--skip-existing-files - skip existing files in get_files
cd445739
AM
313--opts <rpm opts> - additional options for rpm
314-q, --quiet - be quiet,
315--date yyyy-mm-dd - build package using resources from specified CVS date,
316-r <cvstag>, --cvstag <cvstag>
317 - build package using resources from specified CVS tag,
5323fffd 318-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
319-R, --fetch-build-requires
320 - fetch what is BuildRequired,
321-RB, --remove-build-requires
322 - remove all you fetched with -R or --fetch-build-requires
323 remember, this option requires confirmation,
324-FRB, --force-remove-build-requires
325 - remove all you fetched with -R or --fetch-build-requires
326 remember, this option works without confirmation,
06541433
JR
327-sd, --source-distfiles - list sources available from distfiles (intended for offline
328 operations; does not work when Icon field is present
329 but icon file is absent),
e15852ab 330-sc, --source-cvs - list sources available from CVS
06541433
JR
331-sdp, --source-distfiles-paths - list sources available from distfiles -
332 paths relative to distfiles directory (intended for offline
333 operations; does not work when Icon field is present
334 but icon file is absent),
a7eefc54 335-sf, --source-files - list sources - bare filenames (intended for offline
336 operations; does not work when Icon field is present
3621e588 337 but icon file is absent),
8bd5e66d 338-lsp, --source-paths - list sources - filenames with full local paths (intended for
a7eefc54 339 offline operations; does not work when Icon field is present
3621e588 340 but icon file is absent),
2dddf439
ER
341-su, --source-urls - list urls - urls to sources and patches
342 intended for copying urls with spec with lots of macros in urls
cd445739
AM
343-T <cvstag> , --tag <cvstag>
344 - add cvs tag <cvstag> for files,
345-Tvs, --tag-version-stable
094bd95b 346 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
347-Ts, --tag-stable
348 - add cvs tag STABLE for files,
cd445739 349-Tv, --tag-version
1691a37b 350 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
351-Tp, --tag-prefix <prefix>
352 - add <prefix> to NAME-VERSION-RELEASE tags,
353-tt, --test-tag <prefix>
354 - fail if tag is already present,
50321881
JK
355-ir, --integer-release-only
356 - allow only integer and snapshot releases
cd445739
AM
357-v, --verbose - be verbose,
358-u, --try-upgrade - check version, and try to upgrade package
359-un, --try-upgrade-with-float-version
360 - as above, but allow float version
0907f1eb
ER
361 php-pear-Services_Digg/
362--upgrade-version - upgrade to specified version in try-upgrade
deccc50e 363-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
364-Upi, --update-poldek-indexes
365 - refresh or make poldek package index files.
8bd5e66d
ER
366-sp, --skip-patch <patchnumber>
367 - don't apply <patchnumber>. may be repeated.
c890b916 368-np, --nopatch <patchnumber>
8bd5e66d 369 - abort instead of applying patch <patchnumber>
dfe2cb9a
MK
370--show-bconds - show available conditional builds, which can be used
371 - with --with and/or --without switches.
9b78be50
ER
372--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
373 ./repackage.sh script. in other words, the output is
374 parseable by scripts.
24a97174 375--show-avail-bconds - show available bconds
cd445739
AM
376--with/--without <feature>
377 - conditional build package depending on %_with_<feature>/
378 %_without_<feature> macro switch. You may now use
379 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
380 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 381--target <platform>, --target=<platform>
3621e588
ER
382 - build for platform <platform>.
383--init-rpm-dir - initialize ~/rpm directory structure
5a491465 384"
385}
386
390d081d
ER
387# create tempfile. as secure as possible
388tempfile() {
389 mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM.$$
390}
391
31d2bd0b
ER
392# change dependency to specname
393# common changes:
394# - perl(Package::Name) -> perl-Package-Name
395depspecname() {
396 local package="$1"
397
560c4b1a 398 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g};' -e 's/-\(devel\|static\)$//' )
31d2bd0b
ER
399 echo "$package"
400}
401
c890b916 402update_shell_title() {
a0d6396b 403 [ -t 1 ] || return
0b65d15e 404 local len=${COLUMNS:-80}
5c795f16 405 local msg="$(echo "$*" | cut -c-$len)"
0b65d15e 406
e225de91
ER
407 if [ -n "$BE_VERBOSE" ]; then
408 echo >&2 "$(date +%s.%N) $*"
409 fi
410
5c795f16 411 if [ "x$TITLECHANGE" = "xyes" -o "x$TITLECHANGE" = "x" ]; then
138bbc98
ER
412 local pkg
413 if [ -n "$PACKAGE_NAME" ]; then
414 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
415 else
416 pkg=${SPECFILE}
417 fi
418
419 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
a8c9a155 420 msg=$(echo $msg | tr -d '\n\r')
982e358c
MP
421 case "$TERM" in
422 cygwin|xterm*)
423 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
424 ;;
425 screen*)
426 echo >&2 -ne "\033]0;$msg\007"
427 ;;
428 esac
429 fi
c890b916
ER
430}
431
7e40520f
ER
432# set TARGET from BuildArch: from SPECFILE
433set_spec_target() {
ce40491a 434 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
b45a3b2a 435 tmp=$(awk '/^BuildArch:/ { print $NF; exit }' $ASSUMED_NAME/$SPECFILE)
ce40491a 436 if [ "$tmp" ]; then
f9109a96 437 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
438 TARGET="$tmp"
439 case "$RPMBUILD" in
440 "rpmbuild")
f9109a96 441 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 442 "rpm")
ce40491a 443 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 444 esac
ce40491a
ER
445 fi
446 fi
7e40520f
ER
447}
448
ace3fd80
ER
449# runs rpm with minimal macroset
450minirpm() {
fa4bf1df 451 # we reset macros not to contain macros.build as all the %() macros are
559d511f 452 # executed here, while none of them are actually needed.
559d511f 453 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
525bf240 454 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
455
456 # TODO: move these to /usr/lib/rpm/macros
20117088 457 cat > $BUILDER_MACROS <<'EOF'
5b5e5f7f 458%x8664 x86_64 amd64 ia32e
f78a0bb7 459%alt_kernel %{nil}
460%_alt_kernel %{nil}
5ff15c97 461%bootstrap_release() %{1}
407b204b
ER
462%requires_releq_kernel_up(s:n:) %{nil}
463%requires_releq_kernel_smp(s:n:) %{nil}
464%requires_releq_kernel(s:n:) %{nil}
6b8134e3 465%requires_releq() %{nil}
bb01dee9 466%pyrequires_eq() %{nil}
559d511f 467%requires_eq() %{nil}
c13be3d1 468%requires_eq_to() %{nil}
99c05e13 469%requires_ge() %{nil}
500b0eb8
ER
470%requires_ge_to() %{nil}
471%requires_ge() %{nil}
407b204b
ER
472%releq_kernel_up(n:) ERROR
473%releq_kernel_smp(n:) ERROR
474%releq_kernel(n:) ERROR
74d9fd14 475%kgcc_package ERROR
237bd3f1 476%_fontsdir ERROR
7141278d 477%ruby_version ERROR
478%ruby_ver_requires_eq() %{nil}
479%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 480%__php_api_requires() %{nil}
7141278d 481%php_major_version ERROR
482%php_api_version ERROR
99f819cf
AM
483%requires_xorg_xserver_extension %{nil}
484%requires_xorg_xserver_xinput %{nil}
485%requires_xorg_xserver_font %{nil}
486%requires_xorg_xserver_videodrv %{nil}
7141278d 487%py_ver ERROR
41035426
ER
488%perl_vendorarch ERROR
489%perl_vendorlib ERROR
703ae20b
ER
490# damn. need it here! - copied from /usr/lib/rpm/macros.build
491%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
492%patchset_source(f:b:) %(
493 base=%{-b*}%{!-b*:10000};
494 start=$(expr $base + %1);
495 end=$(expr $base + %{?2}%{!?2:%{1}});
496 # we need to call seq twice as it doesn't allow two formats
497 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
498 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
499 paste %{tmpdir}/__ps{1,2};
500 rm -f %{tmpdir}/__ps{1,2};
501) \
502%{nil}
991f09a5
ER
503%add_etc_shells(p) %{p:<lua>}
504%remove_etc_shells(p) %{p:<lua>}
709995c4
ER
505%lua_add_etc_shells() %{nil}
506%lua_remove_etc_shells() %{nil}
0ca65fa4
JK
507%required_jdk %{nil}
508%buildrequires_jdk %{nil}
f9063abe 509%pear_package_print_optionalpackages %{nil}
fb198857 510EOF
3d12d055 511 if [ "$NOINIT" = "yes" ] ; then
20117088 512 cat >> $BUILDER_MACROS <<'EOF'
3d12d055
JR
513%_specdir ./
514%_sourcedir ./
515EOF
c039643c 516 fi
fff1b991 517 eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
ace3fd80
ER
518}
519
520cache_rpm_dump() {
521 if [ -n "$DEBUG" ]; then
522 set -x
523 set -v
524 fi
525
d1d24c14 526 if [ -x /usr/bin/rpm-specdump ]; then
525bf240 527 update_shell_title "cache_rpm_dump using rpm-specdump command"
fff1b991 528 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
d1d24c14 529 else
525bf240 530 update_shell_title "cache_rpm_dump using rpmbuild command"
d1d24c14
ER
531 local rpm_dump
532 rpm_dump=`
533 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
534 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
535 case "$RPMBUILD" in
536 rpm)
537 ARGS='-bp'
538 ;;
539 rpmbuild)
540 ARGS='--nodigest --nosignature --nobuild'
541 ;;
542 esac
543 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
544 `
545 if [ $? -gt 0 ]; then
546 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
547 echo "$error" >&2
548 Exit_error err_build_fail
549 fi
d05e8080 550
d1d24c14
ER
551 # make small dump cache
552 rpm_dump_cache=`echo "$rpm_dump" | awk '
553 $2 ~ /^SOURCEURL/ {print}
554 $2 ~ /^PATCHURL/ {print}
555 $2 ~ /^nosource/ {print}
556 $2 ~ /^PACKAGE_/ {print}
557 '`
558 fi
d05e8080 559
13974367 560 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
561}
562
ace3fd80 563rpm_dump() {
cd445739 564 if [ -z "$rpm_dump_cache" ] ; then
45e2a818 565 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
cd445739
AM
566 fi
567 echo "$rpm_dump_cache"
568}
569
f6711e2a 570get_icons() {
d05e8080 571 update_shell_title "get icons"
9d99a240 572 ICONS=$(awk '/^Icon:/ {print $2}' $PACKAGE_DIR/${SPECFILE})
d05e8080
ER
573 if [ -z "$ICONS" ]; then
574 return
575 fi
576
975d7b23 577 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
578}
579
f6711e2a 580parse_spec() {
af4d5315 581 update_shell_title "parsing specfile"
cd445739 582 if [ -n "$DEBUG" ]; then
518ff1fb
ER
583 set -x
584 set -v
cd445739 585 fi
b2975fc3 586
d05e8080 587 # icons are needed for successful spec parse
518ff1fb 588 get_icons
d05e8080 589
9c909460 590 cd $PACKAGE_DIR
cd445739 591 cache_rpm_dump
00fcec7e 592
cd445739
AM
593 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
594 FAIL_IF_NO_SOURCES="no"
595 fi
596
7cbc2d88
ER
597 if [ "$NOSRCS" != "yes" ]; then
598 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
599 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
600 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
601 fi
602
dfe2b2d9
ER
603 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
604 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
605 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 606
0b4119a2 607 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
7854d40c 608 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
0b4119a2
JR
609 fi
610
cd445739
AM
611 if [ -n "$BE_VERBOSE" ]; then
612 echo "- Sources : `nourl $SOURCES`"
613 if [ -n "$PATCHES" ]; then
614 echo "- Patches : `nourl $PATCHES`"
615 else
616 echo "- Patches : *no patches needed*"
617 fi
618 if [ -n "$ICONS" ]; then
619 echo "- Icon : `nourl $ICONS`"
620 else
621 echo "- Icon : *no package icon*"
622 fi
623 echo "- Name : $PACKAGE_NAME"
624 echo "- Version : $PACKAGE_VERSION"
625 echo "- Release : $PACKAGE_RELEASE"
626 fi
13974367
ER
627
628 update_shell_title "parse_spec: OK!"
cd445739
AM
629}
630
f6711e2a 631Exit_error() {
cd445739 632 if [ -n "$DEBUG" ]; then
518ff1fb
ER
633 set -x
634 set -v
cd445739
AM
635 fi
636
637 cd "$__PWD"
638
639 case "$1" in
640 "err_no_spec_in_cmdl" )
641 remove_build_requires
45e2a818 642 echo >&2 "ERROR: spec file name not specified."
cd445739 643 exit 2 ;;
a08d92fc 644 "err_invalid_cmdline" )
45e2a818 645 echo >&2 "ERROR: invalid command line arg ($2)."
a08d92fc 646 exit 2 ;;
cd445739
AM
647 "err_no_spec_in_repo" )
648 remove_build_requires
45e2a818 649 echo >&2 "Error: spec file not stored in CVS repo."
cd445739
AM
650 exit 3 ;;
651 "err_no_source_in_repo" )
652 remove_build_requires
45e2a818 653 echo >&2 "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739 654 exit 4 ;;
703b6deb
ER
655 "err_cvs_add_failed" )
656 echo >&2 "Error: failed to add package to CVS repo."
657 exit 4 ;;
cd445739
AM
658 "err_build_fail" )
659 remove_build_requires
45e2a818 660 echo >&2 "Error: package build failed. (${2:-no more info})"
cd445739 661 exit 5 ;;
78eab2a1
AM
662 "err_no_package_data" )
663 remove_build_requires
45e2a818 664 echo >&2 "Error: couldn't get out package name/version/release from spec file."
78eab2a1 665 exit 6 ;;
ce40491a 666 "err_tag_exists" )
50321881 667 remove_build_requires
45e2a818 668 echo >&2 "Tag ${2} already exists (spec release: ${3})."
50321881 669 exit 9 ;;
ce40491a 670 "err_fract_rel" )
50321881 671 remove_build_requires
45e2a818 672 echo >&2 "Release ${2} not integer and not a snapshot."
50321881 673 exit 10 ;;
fb96e0b5
AM
674 "err_branch_exists" )
675 remove_build_requires
45e2a818 676 echo >&2 "Tree branch already exists (${2})."
fb96e0b5 677 exit 11 ;;
cfc497c0
ER
678 "err_acl_deny" )
679 remove_build_requires
45e2a818 680 echo >&2 "Error: conditions reject building this spec (${2})."
cfc497c0 681 exit 12 ;;
67963237 682 "err_not_implemented" )
779fcca4 683 remove_build_requires
67963237
KK
684 echo >&2 "Error: functionality not yet imlemented"
685 exit 110 ;;
cd445739 686 esac
45e2a818 687 echo >&2 "Unknown error."
73848362 688 exit 100
cd445739
AM
689}
690
f6711e2a 691init_builder() {
cd445739 692 if [ -n "$DEBUG" ]; then
518ff1fb
ER
693 set -x
694 set -v
0dd6320d 695 fi
cd445739 696
4aeb9973 697 if [ "$NOINIT" != "yes" ] ; then
9c909460 698 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
b7cc0c94 699
09bf17c9 700 local macros_ver=$(rpm -E %?rpm_build_macros)
b7cc0c94
ER
701 if [ -z "$macros_ver" ]; then
702 REPO_DIR=$TOP_DIR/packages
703 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
704 else
705 if awk "BEGIN{exit($macros_ver>=$RPM_MACROS_VER)}"; then
706 echo >&2 "builder requires rpm-build-macros >= $RPM_MACROS_VER"
707 exit 1
708 fi
709 REPO_DIR=$TOP_DIR
710 PACKAGE_DIR=$REPO_DIR/$ASSUMED_NAME
711 fi
29e90b02 712 else
9c909460
AM
713 REPO_DIR="."
714 PACKAGE_DIR="."
29e90b02 715 fi
52f3ced3
KK
716 export GIT_WORK_TREE=$PACKAGE_DIR
717 export GIT_DIR=$PACKAGE_DIR/.git
cd445739 718
a8c9a155 719 __PWD=$(pwd)
00fcec7e 720}
721
f6711e2a 722get_spec() {
c890b916 723
2e5be021 724 update_shell_title "get_spec"
c890b916 725
cd445739 726 if [ -n "$DEBUG" ]; then
518ff1fb
ER
727 set -x
728 set -v
cd445739
AM
729 fi
730
9c909460
AM
731 cd "$REPO_DIR"
732 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
6277f15f
ER
733 # XXX: still needed?
734 SPECFILE=$(basename $SPECFILE)
cd445739 735 fi
cd445739 736
1ef6f5de 737 if [ "$NOCVSSPEC" != "yes" ]; then
f4347bd6 738 if [ -d "$ASSUMED_NAME/.git" ]; then
52f3ced3 739 git fetch origin || Exit_error err_no_spec_in_repo
703b6deb 740 elif [ "$ADD_PACKAGE_CVS" = "yes" ]; then
1a135961 741 if [ ! -r "$ASSUMED_NAME/$SPECFILE" ]; then
742 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
743 exit 101
703b6deb 744 fi
f4347bd6 745 Exit_error err_not_implemented
9c909460 746 else
95a5e665
KK
747 (
748 unset GIT_WORK_TREE
749 git clone ${GIT_SERVER}/${ASSUMED_NAME}.git || {
750 # softfail if new package, i.e not yet added to cvs
751 [ ! -f "$ASSUMED_NAME/$SPECFILE" ] && Exit_error err_no_spec_in_repo
752 echo "Warning: package not in CVS - assuming new package"
753 NOCVSSPEC="yes"
754 }
755 )
703b6deb 756 fi
0c3beb90 757
0d494abd 758 cvsignore_df .gitignore
703b6deb
ER
759
760 # add default log format to .cvsignore if it is relative to package dir
761 if [ -n "$LOGFILE" -a "$LOGFILE" = "${LOGFILE##*/}" ]; then
762 # substitute known "macros" to glob
763 local logfile=$(echo "$LOGFILE" | sed -e 's,\$\(PACKAGE_NAME\|DATE\),*,g')
764 if [ "$logfile" ]; then
765 cvsignore_df "$logfile"
daeab113 766 fi
9c909460 767 fi
703b6deb
ER
768
769 # create symlinks for tools
770 if [ "$SYMLINK_TOOLS" != "no" ]; then
771 for a in dropin md5 adapter builder {relup,compile,repackage,rsync,pearize}.sh pldnotify.awk; do
772 [ -f $a ] || continue
773 ln -sf ../$a $ASSUMED_NAME
774 cvsignore_df $a
775 done
776 fi
cd445739 777 fi
049ab214 778
b0121b45 779 if [ -n "$CVSTAG" ]; then
6cfb5e59 780 git checkout "$CVSTAG" -- 2>/dev/null || git checkout -t "origin/$CVSTAG" > /dev/null || exit
52f3ced3
KK
781 git symbolic-ref -q HEAD > /dev/null &&
782 git merge '@{u}'
52020f4c 783 if [ -n "$CVSDATE" ]; then
c4c0f339
KK
784 git checkout $(git rev-list -n1 --before="'$CVSDATE'" $CVSTAG) || exit 1
785 fi
b0121b45
KK
786 fi
787
9c909460 788 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
518ff1fb 789 Exit_error err_no_spec_in_repo
cd445739
AM
790 fi
791
792 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
9c909460 793 chmod $CHMOD_MODE $ASSUMED_NAME/$SPECFILE
cd445739
AM
794 fi
795 unset OPTIONS
9c909460 796 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $ASSUMED_NAME/$SPECFILE
7e40520f 797
ce40491a 798 set_spec_target
cd445739
AM
799}
800
f6711e2a 801find_mirror() {
9c909460 802 cd "$REPO_DIR"
782518da 803 local url="$1"
cd445739 804 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
939f2c12 805 $CVS_COMMAND update mirrors >&2
cd445739
AM
806 fi
807
808 IFS="|"
782518da
ER
809 local origin mirror name rest ol prefix
810 while read origin mirror name rest; do
811 # skip comments and empty lines
2faa4c32 812 if [ -z "$origin" ] || [ "${origin#\#}" != "$origin" ]; then
782518da
ER
813 continue
814 fi
a8c9a155
ER
815 ol=$(echo -n "$origin" | wc -c)
816 prefix=$(echo -n "$url" | head -c $ol)
cd445739 817 if [ "$prefix" = "$origin" ] ; then
a8c9a155 818 suffix=$(echo "$url" | cut -b $((ol+1))-)
cd445739
AM
819 echo -n "$mirror$suffix"
820 return 0
821 fi
822 done < mirrors
823 echo "$url"
824}
825
e7e0d4ec 826# Warning: unpredictable results if same URL used twice
f6711e2a 827src_no() {
9c909460 828 cd $PACKAGE_DIR
cd445739
AM
829 rpm_dump | \
830 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
831 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
832 head -n 1 | xargs
1471f6d6 833}
834
f6711e2a 835src_md5() {
e7e0d4ec 836 [ "$NO5" = "yes" ] && return
cd445739
AM
837 no=$(src_no "$1")
838 [ -z "$no" ] && return
9c909460 839 cd $PACKAGE_DIR
e7e0d4ec
ER
840 local md5
841
842 if [ -f additional-md5sums ]; then
e7e0d4ec 843 md5=$(grep -s -v '^#' additional-md5sums | \
9413a514 844 grep -E "[ ]$(basename "$1")([ ,]|\$)" | \
e7e0d4ec
ER
845 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
846 grep -E '^[0-9a-f]{32}$')
847
848 if [ "$md5" ]; then
849 if [ $(echo "$md5" | wc -l) != 1 ] ; then
850 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
851 fi
852 echo "$md5" | tail -n 1
853 return
854 fi
cd445739 855 fi
e7e0d4ec 856
657d488b 857 source_md5=`grep -i "^#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
e7e0d4ec
ER
858 if [ -n "$source_md5" ]; then
859 echo $source_md5
cd445739 860 else
7805dcb4
PZ
861 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
862 if [ -n "$source_md5" ]; then
863 echo $source_md5
864 else
865 # we have empty SourceX-md5, but it is still possible
866 # that we have NoSourceX-md5 AND NoSource: X
657d488b 867 nosource_md5=`grep -i "^#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
7805dcb4
PZ
868 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
869 echo $nosource_md5
870 fi
cd445739 871 fi
cd445739
AM
872 fi
873}
874
f6711e2a 875distfiles_path() {
06541433
JR
876 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
877}
878
f6711e2a 879distfiles_url() {
06541433 880 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
881}
882
f6711e2a 883distfiles_attic_url() {
06541433 884 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
885}
886
f6711e2a 887good_md5() {
cd445739
AM
888 md5=$(src_md5 "$1")
889 [ "$md5" = "" ] || \
890 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
891}
892
f6711e2a 893good_size() {
a8c9a155 894 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
ce40491a 895 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
896}
897
f6711e2a 898cvsignore_df() {
947025e5 899 if [ "$CVSIGNORE_DF" != "yes" ]; then
900 return
901 fi
0d494abd 902 cvsignore=${PACKAGE_DIR}/.gitignore
7dc8d095
ER
903
904 # add only if not yet there
aa189b05 905 if ! awk -vf="$1" -vc=1 '$0 == f { c = 0 } END { exit c }' $cvsignore 2>/dev/null; then
947025e5 906 echo "$1" >> $cvsignore
907 fi
908}
909
71f8e908 910# returns true if "$1" is ftp, http or https protocol url
f6711e2a 911is_url() {
71f8e908
ER
912 case "$1" in
913 ftp://*|http://*|https://*)
914 return 0
915 ;;
916 esac
917 return 1
918}
919
f6711e2a 920update_md5() {
ecba6ad5
ER
921 if [ $# -eq 0 ]; then
922 return
923 fi
924
925 update_shell_title "update md5"
926 if [ -n "$DEBUG" ]; then
518ff1fb
ER
927 set -x
928 set -v
ecba6ad5
ER
929 fi
930
9c909460 931 cd "$PACKAGE_DIR"
ecba6ad5
ER
932
933 # pass 1: check files to be fetched
934 local todo
935 local need_files
936 for i in "$@"; do
937 local fp=$(nourl "$i")
938 local srcno=$(src_no "$i")
6392b5fd
ER
939 if [ -n "$ADD5" ]; then
940 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
9c909460
AM
941 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
942 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
6392b5fd 943 else
9c909460 944 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
ecba6ad5
ER
945 fi
946 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
947 need_files="$need_files $i"
948 fi
949 done
950
951 # pass 1a: get needed files
952 if [ "$need_files" ]; then
953 get_files $need_files
954 fi
955
956 # pass 2: proceed with md5 adding or updating
957 for i in "$@"; do
958 local fp=$(nourl "$i")
959 local srcno=$(src_no "$i")
9c909460 960 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
e19ad799 961 if [ -z "$md5" ]; then
9c909460 962 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
6c1b2e7d 963 fi
71f8e908 964 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
6c1b2e7d 965 local tag="# Source$srcno-md5:\t"
71f8e908 966 if [[ "$md5" == *NoSource* ]]; then
6c1b2e7d
PZ
967 tag="# NoSource$srcno-md5:\t"
968 elif [ -n "$USEDIGEST" ]; then
969 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
71f8e908 970 fi
ecba6ad5 971 md5=$(md5sum "$fp" | cut -f1 -d' ')
15bf3e99 972 echo "Updating Source$srcno ($md5: $fp)."
ecba6ad5 973 perl -i -ne '
6c1b2e7d
PZ
974 print unless (/^\s*#\s*(No)?Source'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
975 print "'"$tag$md5"'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5 976 ' \
9c909460 977 $PACKAGE_DIR/$SPECFILE
ecba6ad5
ER
978 fi
979 done
980}
981
f6711e2a 982check_md5() {
60499e54 983 local bad
3fbff8b8
ER
984 [ "$NO5" = "yes" ] && return
985
ecba6ad5
ER
986 update_shell_title "check md5"
987
988 for i in "$@"; do
60499e54
AM
989 bad=0
990 if ! good_md5 "$i"; then
991 echo -n "MD5 sum mismatch."
992 bad=1
993 fi
994 if ! good_size "$i"; then
995 echo -n "0 sized file."
996 bad=1
ecba6ad5
ER
997 fi
998
60499e54
AM
999 if [ $bad -eq 1 ]; then
1000 echo " Use -U to refetch sources,"
1001 echo "or -5 to update md5 sums, if you're sure files are correct."
1002 Exit_error err_no_source_in_repo $i
1003 fi
ecba6ad5
ER
1004 done
1005}
1006
f6711e2a 1007get_files() {
7cb24972 1008 update_shell_title "get_files"
cd445739
AM
1009
1010 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1011 set -x
1012 set -v
cd445739
AM
1013 fi
1014
f09c0772 1015 if [ $# -gt 0 ]; then
9c909460 1016 cd "$PACKAGE_DIR"
cd445739 1017
f2e42a41 1018 local nc=0
e7fa3b9f 1019 local get_files_cvs=""
3815b69a 1020 for i in "$@"; do
f2e42a41 1021 nc=$((nc + 1))
dcebdffb 1022 local cvsup=0
3815b69a 1023 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 1024 update_shell_title "$i"
f09c0772 1025 local fp=`nourl "$i"`
ecba6ad5 1026 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 1027 continue
18e5347d 1028 fi
ecba6ad5 1029
cd445739 1030 FROM_DISTFILES=0
e7e0d4ec 1031 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
1032
1033 # we know if source/patch is present in cvs/distfiles
1034 # - has md5 (in distfiles)
1035 # - in cvs... ideas?
1036
1037 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 1038 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
1039 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1040 echo "Warning: no URL given for $i"
1041 fi
08908161 1042 target="$fp"
cd445739 1043
e7e0d4ec 1044 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 1045 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 1046 echo "$fp having proper md5sum already exists"
cd445739
AM
1047 continue
1048 fi
28b34560 1049
bc10f694 1050 # optionally prefer mirror over distfiles if there's mirror
28b34560 1051 # TODO: build url list and then try each url from the list
bc10f694 1052 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
28b34560
ER
1053 url="$im"
1054 else
1055 url=$(distfiles_url "$i")
1056 fi
1057
cd445739
AM
1058 url_attic=$(distfiles_attic_url "$i")
1059 FROM_DISTFILES=1
ecba6ad5
ER
1060 # is $url local file?
1061 if [[ "$url" = [./]* ]]; then
18a52930 1062 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
1063 ${GETLOCAL} $url $target
1064 else
1065 if [ -z "$NOMIRRORS" ]; then
9e9f8920 1066 url=$(find_mirror "$url")
cd445739 1067 fi
9e9f8920
ER
1068
1069 local uri=${url}
1070 # make shorter message for distfiles urls
1071 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1072 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1073 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1074 uri="df: $uri"
1075 fi
1076 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 1077 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1078 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 1079 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1080 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
1081 fi
1082 fi
ecba6ad5
ER
1083
1084 # is it empty file?
1085 if [ ! -s "$target" ]; then
cd445739
AM
1086 rm -f "$target"
1087 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 1088 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
1089 ${GETLOCAL} $url_attic $target
1090 else
1091 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1092 url_attic=$(find_mirror "$url_attic")
cd445739 1093 fi
18a52930 1094 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1095 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1096 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1097 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1098 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739 1099 fi
1cd7fc57 1100 test -s "$target" || rm -f "$target"
cd445739
AM
1101 fi
1102 fi
ecba6ad5
ER
1103
1104 if [ -s "$target" ]; then
947025e5 1105 cvsignore_df $target
1106 else
cd445739
AM
1107 rm -f "$target"
1108 FROM_DISTFILES=0
1109 fi
cd445739
AM
1110 fi
1111
f09c0772 1112 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739 1113 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1114 im=$(find_mirror "$i")
cd445739
AM
1115 else
1116 im="$i"
1117 fi
ce40491a 1118 update_shell_title "${GETURI%% *}: $im"
08908161 1119 ${GETURI} "$im" ${OUTFILEOPT} "$target" || \
33da77c4 1120 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1121 update_shell_title "${GETURI2%% *}: $im"
08908161 1122 ${GETURI2} "$im" ${OUTFILEOPT} "$target"
7e365483 1123 fi
1cd7fc57 1124 test -s "$target" || rm -f "$target"
cd445739
AM
1125 fi
1126
dcebdffb
ER
1127 if [ "$cvsup" = 1 ]; then
1128 continue
1129 fi
1130
cd445739 1131 fi
ecba6ad5
ER
1132
1133 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1134 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
b3b584c5 1135 Exit_error err_no_source_in_repo $i
cd445739 1136 fi
2a5f078d 1137
ecba6ad5 1138 # we check md5 here just only to refetch immediately
a4b50627 1139 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1140 :
1141 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1142 # wrong md5 from distfiles: remove the file and try again
cd445739 1143 # but only once ...
deccc50e 1144 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1145 FROM_DISTFILES=2
1146 rm -f $target
18a52930 1147 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1148 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1149 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1150 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1151 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1152 fi
ecba6ad5 1153 if [ ! -s "$target" ]; then
cd445739 1154 rm -f "$target"
18a52930 1155 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1156 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1157 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1158 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1159 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1160 fi
1161 fi
1162 test -s "$target" || rm -f "$target"
1163 fi
cd445739 1164 done
e7fa3b9f
ER
1165 SHELL_TITLE_PREFIX=""
1166
cd445739
AM
1167
1168 if [ "$CHMOD" = "yes" ]; then
a8c9a155 1169 CHMOD_FILES=$(nourl "$@")
cd445739
AM
1170 if [ -n "$CHMOD_FILES" ]; then
1171 chmod $CHMOD_MODE $CHMOD_FILES
1172 fi
1173 fi
cd445739
AM
1174 fi
1175}
1176
1177make_tagver() {
ce40491a 1178 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1179 set -x
1180 set -v
ce40491a 1181 fi
78eab2a1 1182
ce40491a
ER
1183 # Check whether first character of PACKAGE_NAME is legal for tag name
1184 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1185 TAG_PREFIX=tag_
1186 fi
d712cc12
ER
1187
1188 # NOTE: CVS tags may must not contain the characters `$,.:;@'
392187d9 1189 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
d712cc12 1190
ce40491a
ER
1191 # Remove #kernel.version_release from TAGVER because tagging sources
1192 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1193 # besides, %{_kernel_ver_str} is not expanded.
1194
1195 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1196 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1197
1198 TAGVER=${TAGVER%#*}
ce40491a 1199 echo -n "$TAGVER"
cd445739
AM
1200}
1201
f6711e2a 1202tag_files() {
cd445739
AM
1203 TAG_FILES="$@"
1204
1205 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1206 set -x
1207 set -v
cd445739
AM
1208 fi
1209
73ef63d8
ER
1210 echo "Version: $PACKAGE_VERSION"
1211 echo "Release: $PACKAGE_RELEASE"
cd445739 1212
a18a9761 1213 local TAGVER
73ef63d8 1214 if [ "$TAG_VERSION" = "yes" ]; then
a18a9761 1215 TAGVER=`make_tagver`
48ab9915 1216 echo "tag: $TAGVER"
73ef63d8
ER
1217 fi
1218 if [ -n "$TAG" ]; then
48ab9915 1219 echo "tag: $TAG"
73ef63d8 1220 fi
cd445739 1221
39dcc7de 1222 local OPTIONS="tag $CVS_FORCE"
cd445739 1223
c713aac3
AG
1224 local _tag=$TAG
1225 if [ "$TAG_VERSION" = "yes" ]; then
1226 _tag=$TAGVER
1227 fi;
c713aac3 1228
9c909460 1229 cd "$PACKAGE_DIR"
03db3356 1230
73ef63d8 1231 if [ "$TAG_VERSION" = "yes" ]; then
48ab9915
KK
1232 update_shell_title "tag sources: $TAGVER"
1233 git $OPTIONS $TAGVER || exit
73ef63d8
ER
1234 fi
1235 if [ -n "$TAG" ]; then
48ab9915
KK
1236 update_shell_title "tag sources: $TAG"
1237 git $OPTIONS $TAG $chunk || exit
73ef63d8 1238 fi
cd445739
AM
1239}
1240
f6711e2a 1241branch_files() {
cd445739 1242 TAG=$1
f663f264 1243 echo "Git branch: $TAG"
518ff1fb 1244 shift
cd445739 1245
cd445739 1246 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1247 set -x
1248 set -v
cd445739
AM
1249 fi
1250
f663f264 1251 local OPTIONS="branch $CVS_FORCE"
c10fa4fa 1252
9c909460 1253 cd "$PACKAGE_DIR"
f663f264 1254 git $OPTIONS $TAG || exit
cd445739
AM
1255}
1256
1257
3009b80d
ER
1258# this function should exit early if package can't be built for this arch
1259# this avoids unneccessary BR filling.
1260check_buildarch() {
1261 local out ret
13c3c336 1262 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1263 ret=$?
1264 if [ $ret -ne 0 ]; then
1265 echo >&2 "$out"
1266 exit $ret
1267 fi
1268}
1269
9d99a240
ER
1270# from relup.sh
1271set_release() {
1272 local specfile="$1"
1273 local rel="$2"
1274 local newrel="$3"
1275 sed -i -e "
1276 s/^\(%define[ \t]\+_\?rel[ \t]\+\)$rel\$/\1$newrel/
1277 s/^\(Release:[ \t]\+\)$rel\$/\1$newrel/
1278 " $specfile
1279}
1280
1281set_version() {
1282 local specfile="$1"
bc8502e6
ER
1283 local ver="$2" subver=$ver
1284 local newver="$3" newsubver=$newver
1285
1286 # try handling subver, everything that's not numeric-dotted in version
1287 if grep -Eq '%define\s+subver' $specfile; then
1288 subver=$(echo "$ver" | sed -re 's,^[0-9.]+,,')
1289 ver=${ver%$subver}
1290 newsubver=$(echo "$newver" | sed -re 's,^[0-9.]+,,')
1291 newver=${newver%$newsubver}
1292 fi
9d99a240
ER
1293 sed -i -e "
1294 s/^\(%define[ \t]\+_\?ver[ \t]\+\)$ver\$/\1$newver/
bc8502e6 1295 s/^\(%define[ \t]\+subver[ \t]\+\)$subver\$/\1$newsubver/
9d99a240
ER
1296 s/^\(Version:[ \t]\+\)$ver\$/\1$newver/
1297 " $specfile
1298}
1299
cacef28c 1300try_upgrade() {
cd445739 1301 if [ -n "$TRY_UPGRADE" ]; then
9d99a240 1302 local TNOTIFY TNEWVER TOLDVER
ce40491a 1303 update_shell_title "build_package: try_upgrade"
9d99a240 1304
cacef28c 1305 cd "$PACKAGE_DIR"
1306
0907f1eb
ER
1307 if [ "$UPGRADE_VERSION" ]; then
1308 TNEWVER=$UPGRADE_VERSION
cd445739 1309 else
0907f1eb
ER
1310 if [ -n "$FLOAT_VERSION" ]; then
1311 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE -n) || exit 1
1312 else
1313 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE) || exit 1
1314 fi
cd445739 1315
b9bef5ce
ER
1316 # pldnotify.awk does not set exit codes, but it has match for ERROR
1317 # in output which means so.
1318 if [[ "$TNOTIFY" = *ERROR* ]]; then
1319 echo >&2 "$TNOTIFY"
1320 exit 1
1321 fi
1322
0907f1eb
ER
1323 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
1324 fi
cd445739
AM
1325
1326 if [ -n "$TNEWVER" ]; then
1327 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
9d99a240 1328 echo "New version found, updating spec file from $TOLDVER to version $TNEWVER"
257af81b
ER
1329 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1330 cp -f $SPECFILE $SPECFILE.bak
1331 fi
cd445739 1332 chmod +w $SPECFILE
cacef28c 1333 set_release $SPECFILE $PACKAGE_RELEASE 1
9d99a240 1334 set_version $SPECFILE $PACKAGE_VERSION $TNEWVER
518ff1fb 1335 parse_spec
6decb793
ER
1336 if [ "$PACKAGE_VERSION" != "$TNEWVER" ]; then
1337 echo >&2 "Upgrading version failed, you need to update spec yourself"
1338 exit 1
1339 fi
cacef28c 1340 return 1
cd445739
AM
1341 fi
1342 fi
cacef28c 1343 return 0
1344}
1345
1346build_package() {
1347 update_shell_title "build_package"
1348 if [ -n "$DEBUG" ]; then
1349 set -x
1350 set -v
1351 fi
1352
9c909460 1353 cd "$PACKAGE_DIR"
2a5f078d 1354
cd445739
AM
1355 case "$COMMAND" in
1356 build )
1357 BUILD_SWITCH="-ba" ;;
1358 build-binary )
1359 BUILD_SWITCH="-bb" ;;
1360 build-source )
1361 BUILD_SWITCH="-bs --nodeps" ;;
1362 build-prep )
1363 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1364 build-build )
1365 BUILD_SWITCH="-bc" ;;
1366 build-install )
1367 BUILD_SWITCH="-bi" ;;
1368 build-list )
1369 BUILD_SWITCH="-bl" ;;
1370
cd445739 1371 esac
c890b916 1372
2e5be021 1373 update_shell_title "build_package: $COMMAND"
cd445739
AM
1374 if [ -n "$LOGFILE" ]; then
1375 LOG=`eval echo $LOGFILE`
1376 if [ -d "$LOG" ]; then
1377 echo "Log file $LOG is a directory."
1378 echo "Parse error in the spec?"
518ff1fb 1379 Exit_error err_build_fail
cd445739
AM
1380 fi
1381 if [ -n "$LASTLOG_FILE" ]; then
1382 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1383 fi
390d081d 1384 RES_FILE=$(tempfile)
525bf240 1385
9c909460 1386 (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1387 RETVAL=`cat $RES_FILE`
1388 rm $RES_FILE
1389 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1390 if [ "$RETVAL" -eq "0" ]; then
1391 mv $LOG $LOGDIROK
1392 else
1393 mv $LOG $LOGDIRFAIL
1394 fi
1395 fi
8ba5cdda 1396 else
9c909460 1397 eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE
cd445739 1398 RETVAL=$?
8ba5cdda 1399 fi
cd445739
AM
1400 if [ "$RETVAL" -ne "0" ]; then
1401 if [ -n "$TRY_UPGRADE" ]; then
cacef28c 1402 echo "\nUpgrade package to new version failed."
257af81b 1403 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
cacef28c 1404 echo "Restoring old spec file."
257af81b
ER
1405 mv -f $SPECFILE.bak $SPECFILE
1406 fi
cacef28c 1407 echo ""
cd445739 1408 fi
518ff1fb 1409 Exit_error err_build_fail
cd445739
AM
1410 fi
1411 unset BUILD_SWITCH
1412}
1413
f6711e2a 1414nourl() {
cd445739
AM
1415 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1416}
1417
f6711e2a 1418install_required_packages() {
cd445739
AM
1419 run_poldek -vi $1
1420 return $?
1421}
1422
f6711e2a 1423find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
fa4bf1df 1424 local SPEC="$1"
fa4bf1df
ER
1425 awk -F"\n" '
1426 /^%changelog/ { exit }
fa4bf1df
ER
1427 /^%bcond_with/{
1428 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
8ff97f39
ER
1429 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1430 gsub(/[ \t]+/, "_", bcond);
fa4bf1df
ER
1431 print bcond
1432 }' $SPEC | LC_ALL=C sort -u
1433}
1434
117d9861 1435process_bcondrc() {
301cbfd4
ER
1436 # expand bconds from ~/.bcondrc
1437 # The file structure is like gentoo's package.use:
1438 # ---
1439 # * -selinux
1440 # samba -mysql -pgsql
47a8df12 1441 # w32codec-installer license_agreement
301cbfd4
ER
1442 # php +mysqli
1443 # ---
fa4bf1df 1444 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1445 :
1446 else
1447 return
1448 fi
301cbfd4 1449
117d9861 1450 SN=${SPECFILE%%\.spec}
c8a3e2ac 1451
117d9861
ER
1452 local bcondrc=$HOME/.bcondrc
1453 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1454
117d9861 1455 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1456
117d9861
ER
1457 while read pkg flags; do
1458 # ignore comments
1459 [[ "$pkg" == \#* ]] && continue
1460
1461 # any package or current package?
1462 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1463 for flag in $flags; do
1464 local opt=${flag#[+-]}
1465
1466 # use only flags which are in this package.
1467 if [[ $bcond_avail = *${opt}* ]]; then
1468 if [[ $flag = -* ]]; then
1469 if [[ $BCOND != *--with?${opt}* ]]; then
1470 BCOND="$BCOND --without $opt"
1471 fi
1472 else
1473 if [[ $BCOND != *--without?${opt}* ]]; then
1474 BCOND="$BCOND --with $opt"
301cbfd4
ER
1475 fi
1476 fi
117d9861
ER
1477 fi
1478 done
1479 fi
1480 done < $bcondrc
1481 update_shell_title "parse ~/.bcondrc: DONE!"
1482}
1483
8ff97f39 1484set_bconds_values() {
117d9861
ER
1485 update_shell_title "set bcond values"
1486
1487 AVAIL_BCONDS_WITHOUT=""
1488 AVAIL_BCONDS_WITH=""
8ff97f39 1489
5a28189c 1490 if grep -Eq '^# *_with' ${SPECFILE}; then
8ff97f39
ER
1491 echo >&2 "ERROR: This spec has old style bconds."
1492 exit 1
1493 fi
1494
1495 if ! grep -q '^%bcond' ${SPECFILE}; then
117d9861 1496 return
301cbfd4
ER
1497 fi
1498
117d9861
ER
1499 local bcond_avail=$(find_spec_bcond $SPECFILE)
1500 process_bcondrc "$SPECFILE"
1501
fa4bf1df 1502 update_shell_title "parse bconds"
2a5f078d 1503
8ff97f39
ER
1504 local opt bcond
1505 for opt in $bcond_avail; do
1506 case "$opt" in
1507 without_*)
1508 bcond=${opt#without_}
10d92f71
ER
1509 case "$BCOND" in
1510 *--without?${bcond}*)
8ff97f39 1511 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
10d92f71
ER
1512 ;;
1513 *)
8ff97f39 1514 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
10d92f71
ER
1515 ;;
1516 esac
cd445739 1517 ;;
8ff97f39
ER
1518 with_*)
1519 bcond=${opt#with_}
10d92f71
ER
1520 case "$BCOND" in
1521 *--with?${bcond}*)
8ff97f39 1522 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
10d92f71
ER
1523 ;;
1524 *)
8ff97f39 1525 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
10d92f71
ER
1526 ;;
1527 esac
cd445739 1528 ;;
8ff97f39
ER
1529 *)
1530 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1531 exit 1
1532 ;;
1533 esac
1534 done
cd445739
AM
1535}
1536
f6711e2a 1537run_sub_builder() {
cd445739 1538 package_name="${1}"
af6b168f 1539 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1540 #
1541